//DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
//                    Version 2, December 2004
//
// Copyright (C) 2004 Sam Hocevar
//  22 rue de Plaisance, 75014 Paris, France
// Everyone is permitted to copy and distribute verbatim or modified
// copies of this license document, and changing it is allowed as long
// as the name is changed.
//
//            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
//   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
//
//  0. You just DO WHAT THE FUCK YOU WANT TO.
// Author : Laurent BERNE
// 1 fvrier 2005 : premire release 0.0
// 2 fvrier 2005 : permet de placer la liste des fichiers ini dans un fichier dport sur le rseau
// 2 fvrier 2005 : permet de fixer la dure du splasch screen




unit UnitfMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Inifiles, StdCtrls, ExtCtrls,ShellAPI;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }

    
    FConfirmUpdate : boolean;
    FIniFileForFilesListPath : string;
    FApplicationToRun : string;
    procedure FCopyFile(Source : string; destination : string);
    procedure FDoWork;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FCopyFile(Source, Destination: string);
var
 DirectoryDestination : string;
 mes : string;
 Confirm : string;

begin
 try

   DirectoryDestination := ExtractFileDir(Destination);
   if not DirectoryExists( DirectoryDestination) then
    ForceDirectories(DirectoryDestination);
    if FileExists(Destination) and FConfirmUpdate then
     begin
     Confirm :='Update : '+ Destination;
     if MessageBox(Handle,PChar(Confirm),'Avertissement',MB_ICONEXCLAMATION or MB_OKCANCEL) = IDOK then
      CopyFile(PChar(Source),PChar(Destination),FALSE)
     end
    else
     CopyFile(PChar(Source),PChar(Destination),FALSE)
  except
       mes :=    'Error in copying '+ Destination;
       MessageBox(Handle,PChar(mes),'Error',MB_ICONSTOP or MB_OK);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
 IniFile : TIniFile;
 Pix : string;
begin

 IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 Width := IniFile.ReadInteger('Options','Width',200);
 Height := IniFile.ReadInteger('Options','Height',75);
 FConfirmUpdate := IniFile.ReadBool('Options','ConfirmUpdate',True);
 Pix :=IniFile.ReadString('Options','Pix','');
 if (Pix <> '') and  (FileExists(ExtractFileDir(Application.ExeName)+'\'+ Pix)) then
  Image1.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\'+ Pix ) ;
 FIniFileForFilesListPath :=IniFile.ReadString('Options','IniFileForFilesList','');
 // si pas de rpertoire prciser dans FIniFileForFilesListPath alors rpertoire courant
 if ExtractFileDir(FIniFileForFilesListPath) = '' then
  FIniFileForFilesListPath := ExtractFileDir(Application.ExeName) +'\' + FIniFileForFilesListPath;
  FApplicationToRun := ExtractFileDir(Application.ExeName) +'\'+ IniFile.ReadString('Options','Run','');
  Timer1.Interval :=  IniFile.ReadInteger('Options','SplashWait',2000);
 IniFile.Free;
 Timer1.Enabled := True;
end;

procedure TForm1.FDoWork;
var
 IniFile : TIniFile;
 Files : TStringList;
 FileSource : string;
 FileDestination : string;
 i: integer;    

begin

 IniFile := TIniFile.Create(FIniFileForFilesListPath );
 Files := TStringList.Create;
 Files.Duplicates := dupIgnore;
 IniFile.ReadSection('Files',Files);

 for i:=0 to Files.Count -1 do
  begin
   FileDestination :=   ExtractFileDir(Application.ExeName)+'\'+Files.Strings[i]   ;
   FileSource := IniFile.ReadString('Files',Files.Strings[i],'');
   if FileExists(FileDestination )then
    begin
      if FileAge(FileDestination) < FileAge(FileSource) then
        FCopyFile(FileSource,FileDestination);
    end
   else
    begin 
      if FileExists(FileSource) then
          FCopyFile(FileSource,FileDestination );
    end;
  end;

 Files.Free;
 IniFile.Free;

 
 if FileExists(FApplicationToRun) then
   ShellExecute(0,'open',PChar(FApplicationToRun),nil,PChar( ExtractFileDir(Application.ExeName)),0);
 Close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled := False;
FDoWork;
end;

end.
